package com.srs.quiltmaker.android;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.StringTokenizer;
import java.util.Vector;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.util.Log;
import android.view.View.OnClickListener;
import android.widget.AdapterView.OnItemClickListener;

import com.srs.android.widgets.LayeredImageView;
import com.srs.quiltmaker.android.ui.BackgroundClickListener;
import com.srs.quiltmaker.android.ui.BackgroundSelectNextClickListener;
import com.srs.quiltmaker.android.ui.bean.Layer;
import com.srs.quiltmaker.android.ui.bean.QuiltBackgroundItem;
import com.srs.quiltmaker.android.util.AppConstants;
import com.srs.quiltmaker.android.util.ImageDownloader;

public class BackgroundSelectionActivity extends BaseSelectionActivity {

    Layer background = new Layer();
    Vector backgrounds = null;
    LayeredImageView layerView;
    
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
	}
	
	/**
	 * Implementation of the abstract parent method for initing this class.
	 */
	public void onCreateInit() {
		backgrounds = getBackgrounds();
		// copy paste code
		//prepAppDataStorage();
	}

	/**
	 * Implmentation of the abstract parent method for this object.
	 */
	public int getBackgroundResource() {
		return R.raw.steponeheader;
	}

	public void setUpDisplayLayers(LayeredImageView layerView) {
		background.setVisible(true);
		layerView.addLayer(background);

		// Save off for later
		this.layerView = layerView;
	}

	public Vector getGalleryItems() {
		return backgrounds;
	}

	public OnItemClickListener getGalleryItemClickListener() {
		
		BackgroundClickListener cl = new BackgroundClickListener(backgrounds,layerView,background,this);
		return cl;		
	}

	public OnClickListener getResetMenuClickListener() {
		ResetClickListener resetClick = new ResetClickListener(this,background);
		return resetClick;
	}

	public OnClickListener getNextMenuClickListener() {
		 BackgroundSelectNextClickListener nextClick = new BackgroundSelectNextClickListener(this,background);
		 return nextClick;
	}
	
	/** Orig code **/
//    /** Called when the activity is first created. */
//    @Override
//    public void onCreate(Bundle savedInstanceState) {
//        super.onCreate(savedInstanceState);
//        
//        Vector backgrounds = getBackgrounds();
//        
//        HeaderFooterLayout mainLayout = new HeaderFooterLayout(this);
//        mainLayout.setOrientation(LinearLayout.VERTICAL);
//        
//        
//        //
//        //   ****  HEADER ****
//        //
//        CenteredImageView header = new CenteredImageView(this);
//        header.setImageResource(R.raw.steponeheader);
//        header.setConsumeParentWidth(true);
//        header.setLayoutParams(new LayoutParams(LayoutParams.FILL_PARENT,LayoutParams.WRAP_CONTENT));
//        mainLayout.addHeaderView(header);
//        
//   
//        //
//        //   ****  BODY ****
//        //
//        LayeredImageView theView = new LayeredImageView(this);
//        theView.setLayoutParams(new LayoutParams(LayoutParams.FILL_PARENT,LayoutParams.FILL_PARENT));
//        theView.setMinimumHeight(100);
//        theView.setMaxHeight(400);
//        mainLayout.addBodyView(theView);
//        
//        Layer background = new Layer();
//        background.setVisible(false);
//        
//        theView.addLayer(background);
//        
//        
//        //
//        //   ****  FOOTER ****
//        //
//        LinearLayout footerLayout = new LinearLayout(this);
//        footerLayout.setOrientation(LinearLayout.VERTICAL);
//        
//        
//        Gallery backgroundGallery = new Gallery(this);
//        backgroundGallery.setMinimumHeight(100);
//        backgroundGallery.setMinimumWidth(100);
//        backgroundGallery.setSpacing(4);
//        backgroundGallery.setLayoutParams(new Gallery.LayoutParams(LayoutParams.FILL_PARENT,LayoutParams.WRAP_CONTENT));
//        BackgroundGaleryAdaptor gadaptor = new BackgroundGaleryAdaptor(this);
//        gadaptor.setItemVector(backgrounds);
//        backgroundGallery.setAdapter(gadaptor);
//        BackgroundClickListener cl = new BackgroundClickListener(backgrounds,theView,background,this);
//        backgroundGallery.setOnItemClickListener( cl);
//        
//        footerLayout.addView(backgroundGallery,new Gallery.LayoutParams(LayoutParams.FILL_PARENT,LayoutParams.WRAP_CONTENT));
//
//        
//        NavigationView footerMenu = new NavigationView(this);
//        footerMenu.setBackgroundColor(0xFFe3e2a6);
//        
//        BackgroundSelectNextClickListener nextClick = new BackgroundSelectNextClickListener(this,background);
//        MouseoverNavigationElement nextButton = new MouseoverNavigationElement("Next",R.raw.nextbtnselected,
//        		R.raw.nextbtnsonselected,nextClick);
//        nextButton.setLocationMode(MouseoverNavigationElement.LOC_FLOAT_RIGHT);
//        footerMenu.add(nextButton);
//        
//		ResetClickListener resetClick = new ResetClickListener(this,background);
//        MouseoverNavigationElement resetButton = new MouseoverNavigationElement("Next",R.raw.resetbtnselected,
//        		R.raw.resetbtnnonselected,resetClick);
//        resetButton.setLocationMode(MouseoverNavigationElement.LOC_FLOAT_LEFT);
//        footerMenu.add(resetButton);
//        footerLayout.addView(footerMenu);
//
//        
//        mainLayout.addFooterView(footerLayout);
//        setContentView(mainLayout);
//    }
    
    
    /**
     * Temp utility method to load all the backgrounds.   Will  be moved elsewhere later.
     * 
     * @return
     */
    private Vector getBackgrounds() {
    	
    	Vector bkgrounds = new Vector();
    	
    	File bgDir = getDir(AppConstants.APP_BACKGROUND_DIR,Context.MODE_PRIVATE);
    	String path=bgDir.getAbsolutePath() +  "/" + "backgrounds.rc";
    	Log.v("BackgroundSelectActivity","path is " + path);
    	
    	tempDownload(AppConstants.HTTP_ROOT_DIR + "/backgrounds.rc",path);
    	
    	try {
			BufferedReader rd = new BufferedReader(new FileReader(path));
			String line = null;
			line=rd.readLine();
			while(line != null) {
				
				if(! line.startsWith("#")) {
					StringTokenizer st = new StringTokenizer(line,",");
					String name = st.nextToken();
					String fileThumb = st.nextToken();
					String file = st.nextToken();
					
					QuiltBackgroundItem item = new QuiltBackgroundItem(name);
					item.setBackgroundFilename(file);
					item.setBackgroundThumFilename(fileThumb);
					item.setRootDirectory(bgDir.getAbsolutePath());
					
			    	tempDownload(AppConstants.HTTP_ROOT_DIR + "/" + file,bgDir.getAbsolutePath() + "/" + file);
			    	tempDownload(AppConstants.HTTP_ROOT_DIR + "/" + fileThumb,bgDir.getAbsolutePath() + "/" + fileThumb);

					Log.i("BackgroundSelectActivity","BK is " + item.getBackgroundFilename());
					Log.i("BackgroundSelectActivity","TH is " + item.getBackgroundThumFilename());
					loadBackgroundImages(item);
					bkgrounds.add(item);
				}
				
				line = rd.readLine();
			}
			
			rd.close();
			
		} catch (FileNotFoundException e) {
			Log.e("BackgroundSelectActivity","getBackgrounds unable to find background rc file.",e);
			return bkgrounds;
		} catch (IOException e) {
			Log.e("BackgroundSelectActivity","getBackgrounds IO error reading background rc file.",e);
			return bkgrounds;
		}
    	
    	return bkgrounds;
    }
    
    /**
     * Utility method to load background image files into bitamaps and put them into the ui beans.
     * 
     * @param item
     */
    private void loadBackgroundImages(QuiltBackgroundItem item) {
    	//Bitmap img = BitmapFactory.decodeFile(item.getRootDirectory() + "/" + item.getBackgroundThumFilename());
    	//item.setBackgroundThum(img);
    	
    	Bitmap img=null;
    	img = BitmapFactory.decodeFile(item.getRootDirectory() + "/" + item.getBackgroundFilename());
    	item.setBackground(img);
    }
    
    private void tempDownload(String URIPath,String file) {
    	ImageDownloader downloader = new ImageDownloader();
    	downloader.DownloadFromUrl(URIPath,file);
    }

}
