package com.srs.quiltmaker.android;

import android.app.Activity;
import android.os.Bundle;
import android.widget.LinearLayout;

import com.srs.android.widgets.CenteredImageView;
import com.srs.android.widgets.MouseoverNavigationElement;
import com.srs.android.widgets.NavigationView;
import com.srs.android.widgets.layout.HeaderFooterLayout;
import com.srs.quiltmaker.android.ui.InstructionScreenNextClickListener;

public class InstructionScreen extends Activity {

    public void onCreate(Bundle savedInstanceState) {
    	
        super.onCreate(savedInstanceState);
        
        //
        // Build UI -- ignoring crazy xml goo
        //
        HeaderFooterLayout layout = new HeaderFooterLayout(this);
        layout.setOrientation(LinearLayout.VERTICAL);
        
    
        CenteredImageView splashImage = new CenteredImageView(this);
        splashImage.setImageResource(R.raw.instructionscreenbackground);
        splashImage.setConsumeParentHeight(true);
        splashImage.setConsumeParentWidth(true);
        layout.addBodyView(splashImage);
        
        
        NavigationView footerMenu = new NavigationView(this);
        footerMenu.setBackgroundColor(0xFFe3e2a6);
        
        MouseoverNavigationElement nextButton = new MouseoverNavigationElement("Next",R.raw.nextbtnselected,
        		R.raw.nextbtnsonselected,new InstructionScreenNextClickListener(this));
        nextButton.setLocationMode(MouseoverNavigationElement.LOC_FLOAT_RIGHT);
        footerMenu.add(nextButton);
        
        
        layout.addFooterView(footerMenu);
        setContentView(layout);
    }
}
