package com.srs.quiltmaker.android;

import java.util.Properties;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.widget.LinearLayout;

import com.srs.android.widgets.CenteredImageView;
import com.srs.android.widgets.MouseoverNavigationElement;
import com.srs.android.widgets.NavigationView;
import com.srs.android.widgets.layout.HeaderFooterLayout;
import com.srs.quiltmaker.android.ui.InstructionScreenNextClickListener;
import com.srs.quiltmaker.android.ui.OrderCompleteStartNewClickListener;
import com.srs.quiltmaker.android.util.StateStorageUtil;

public class OrderCompleteActivity extends Activity {

	   /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
    	
    	//
        // Initialize state
    	//
        Properties state = StateStorageUtil.initStateStorage(this);
        
    	//
    	// Build UI
    	//
        super.onCreate(savedInstanceState);
        
        HeaderFooterLayout layout = new HeaderFooterLayout(this);
        layout.setOrientation(LinearLayout.VERTICAL);
    
        CenteredImageView splashImage = new CenteredImageView(this);
        splashImage.setImageResource(R.raw.orderplacedbackground);
        splashImage.setConsumeParentHeight(true);
        splashImage.setConsumeParentWidth(true);
        splashImage.setCenterVertical(false);
        layout.addBodyView(splashImage);
        
        
        NavigationView footerMenu = new NavigationView(this);
        footerMenu.setBackgroundColor(0xFFe3e2a6);
        
        MouseoverNavigationElement nextButton = new MouseoverNavigationElement("Next",R.raw.startnewbtnselected,
        		R.raw.startnewbtn,new OrderCompleteStartNewClickListener(this));
        nextButton.setLocationMode(MouseoverNavigationElement.LOC_FLOAT_RIGHT);
        footerMenu.add(nextButton);
        layout.addFooterView(footerMenu);
        setContentView(layout);
        
        // reset state, were're starting over boys.
		StateStorageUtil.createNewProperties(this);
		
    }
}
