package com.srs.quiltmaker.android;

import java.io.File;
import java.util.Vector;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.view.View.OnClickListener;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.ScrollView;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;
import android.widget.RadioGroup.LayoutParams;

import com.srs.android.widgets.CenteredImageView;
import com.srs.android.widgets.LayeredImageView;
import com.srs.android.widgets.MouseoverNavigationElement;
import com.srs.android.widgets.NavigationView;
import com.srs.android.widgets.layout.HeaderFooterLayout;
import com.srs.quiltmaker.android.ui.OrderDetailNextClickListener;
import com.srs.quiltmaker.android.ui.bean.Layer;
import com.srs.quiltmaker.android.ui.bean.QuiltBackgroundItem;
import com.srs.quiltmaker.android.util.AppConstants;

public class OrderDetailsActivity extends Activity {

	   Layer background=new Layer();
	    Layer subject=new Layer();
	    Vector subjects=null;
	    LayeredImageView layerView;
	    
	    
	    public void onCreate(Bundle savedInstanceState) {
	    	super.onCreate(savedInstanceState);
	    	
	        
	        //
	        //  Init layers from pervious steps
	        //
//	    	onCreateInit();
	        
	        HeaderFooterLayout mainLayout = new HeaderFooterLayout(this);
	        mainLayout.setOrientation(LinearLayout.VERTICAL);
	        
	        
	        //
	        //   ****  HEADER ****
	        //
	        CenteredImageView header = new CenteredImageView(this);
	        header.setImageResource(getBackgroundResource());
	        header.setConsumeParentWidth(true);
	        header.setLayoutParams(new LayoutParams(LayoutParams.FILL_PARENT,LayoutParams.WRAP_CONTENT));
	        mainLayout.addHeaderView(header);
	        
	   
	        //
	        //   ****  BODY ****
	        //
	        ScrollView orderInfo = new ScrollView(this);
	        orderInfo.setFillViewport(true);
	        orderInfo.setLayoutParams(new LayoutParams(LayoutParams.FILL_PARENT,LayoutParams.FILL_PARENT));
	        
	        TableLayout tlayout = new TableLayout(this);
	        tlayout.setLayoutParams(new LayoutParams(LayoutParams.FILL_PARENT,LayoutParams.FILL_PARENT));
	        orderInfo.addView(tlayout);
	        	        
	        mainLayout.addBodyView(orderInfo);
	        
	        TableRow tr = new TableRow(this);
	        
	        //
	        // SHIPPING ADDRESS header
	        //
	        TextView headertext = new TextView(this);
	        headertext.setText("");
	        tr.addView(headertext);
	        headertext = new TextView(this);
	        headertext.setText("Shipping Address");
	        tr.addView(headertext);
	        tlayout.addView(tr);
	        
	        
	        //
	        // Name
	        //
	        tr = new TableRow(this);
	        TextView label = new TextView(this);
	        label.setText("Name ");
	        tr.addView(label);
	        
	        EditText nameText = new EditText(this);
	        nameText.setText("Your Name");
	        tr.addView(nameText);
	        tlayout.addView(tr);

	        //
	        // Address
	        //
	        tr = new TableRow(this);
	        label = new TextView(this);
	        label.setText("Address ");
	        tr.addView(label);
	        
	        EditText textWidget = new EditText(this);
	        textWidget.setText("Your Addr Line 1");
	        tr.addView(textWidget);
	        tlayout.addView(tr);

	        //
	        // City
	        //
	        tr = new TableRow(this);
	        label = new TextView(this);
	        label.setText("City ");
	        tr.addView(label);
	        textWidget = new EditText(this);
	        textWidget.setText("City");
	        tr.addView(textWidget);
	        tlayout.addView(tr);


	        //
	        // Prov
	        //
	        tr = new TableRow(this);
	        label = new TextView(this);
	        label.setText("State/Prov");
	        tr.addView(label);
	        textWidget = new EditText(this);
	        textWidget.setText("State/Prov");
	        tr.addView(textWidget);
	        tlayout.addView(tr);

	        
	        //
	        // Zip
	        //
	        tr = new TableRow(this);
	        label = new TextView(this);
	        label.setText("Zip");
	        tr.addView(label);
	        textWidget = new EditText(this);
	        textWidget.setText("Zip");
	        tr.addView(textWidget);
	        tlayout.addView(tr);

	        
	        //
	        // PAYMENT INFO
	        //
	        tr = new TableRow(this);
	        headertext = new TextView(this);
	        headertext.setText("");
	        tr.addView(headertext);
	        headertext = new TextView(this);
	        headertext.setText("Payment Information");
	        tr.addView(headertext);
	        tlayout.addView(tr);
	        
	        tr = new TableRow(this);
	        label = new TextView(this);
	        label.setText("Card Number");
	        tr.addView(label);
	        textWidget = new EditText(this);
	        textWidget.setText("PaymentCard#");
	        tr.addView(textWidget);
	        tlayout.addView(tr);

	        tr = new TableRow(this);
	        label = new TextView(this);
	        label.setText("Expiration");
	        tr.addView(label);
	        textWidget = new EditText(this);
	        textWidget.setText("Expiration");
	        tr.addView(textWidget);
	        tlayout.addView(tr);
	        
	        
	        tr = new TableRow(this);
	        label = new TextView(this);
	        label.setText("CVC");
	        tr.addView(label);
	        textWidget = new EditText(this);
	        textWidget.setText("CVC");
	        tr.addView(textWidget);
	        tlayout.addView(tr);
	        
	        //
	        //   ****  FOOTER ****
	        //
	        LinearLayout footerLayout = new LinearLayout(this);
	        footerLayout.setOrientation(LinearLayout.VERTICAL);
	        
	        
//	        Gallery backgroundGallery = new Gallery(this);
//	        backgroundGallery.setMinimumHeight(100);
//	        backgroundGallery.setMinimumWidth(100);
//	        backgroundGallery.setSpacing(4);
//	        backgroundGallery.setLayoutParams(new Gallery.LayoutParams(LayoutParams.FILL_PARENT,LayoutParams.WRAP_CONTENT));
//	        BackgroundGaleryAdaptor gadaptor = new BackgroundGaleryAdaptor(this);
//	        gadaptor.setItemVector(getGalleryItems());
//	        backgroundGallery.setAdapter(gadaptor);
//	        backgroundGallery.setOnItemClickListener(getGalleryItemClickListener());
//	        
//	        footerLayout.addView(backgroundGallery,new Gallery.LayoutParams(LayoutParams.FILL_PARENT,LayoutParams.WRAP_CONTENT));

	        
	        NavigationView footerMenu = new NavigationView(this);
	        footerMenu.setBackgroundColor(0xFFe3e2a6);
	        
	        MouseoverNavigationElement nextButton = new MouseoverNavigationElement("Next",R.raw.nextbtnselected,
	        		R.raw.nextbtnsonselected,getNextMenuClickListener());
	        nextButton.setLocationMode(MouseoverNavigationElement.LOC_FLOAT_RIGHT);
	        footerMenu.add(nextButton);
	        
	        MouseoverNavigationElement resetButton = new MouseoverNavigationElement("Reset",R.raw.resetbtnselected,
	        		R.raw.resetbtnnonselected,getResetMenuClickListener());
	        resetButton.setLocationMode(MouseoverNavigationElement.LOC_FLOAT_LEFT);
	        footerMenu.add(resetButton);
	        footerLayout.addView(footerMenu);

	        mainLayout.addFooterView(footerLayout);
	        setContentView(mainLayout);
	        //Log.d("ThirdActivity","Internals: " + theView.getHeight() + "," + theView.getWidth());
	    }
	    
		/**
		 * Implmentation of the abstract parent method for this object.
		 */
		public int getBackgroundResource() {
			return R.raw.stepfiveheader;
		}

		public OnClickListener getResetMenuClickListener() {
			return new ResetClickListener(this,null);
		}

		public OnClickListener getNextMenuClickListener() {
			OrderDetailNextClickListener nextClick = new OrderDetailNextClickListener(
					this, subject);
			return nextClick;
		}

		public void prepAppDataStorage() {
	    	QuiltBackgroundItem bkground = (QuiltBackgroundItem) background.getLayerData();
	    	if(bkground== null)
	    		return;
	    	
	    	File bgDataDir = getDir(AppConstants.APP_BACKGROUND_DATA_DIR,Context.MODE_PRIVATE);
	    	String resourcesPath = bgDataDir.getAbsolutePath() + "/" + bkground.getName() + "/" + AppConstants.GREETING_CACHE_DIR;
	    	
	    	File subBaseDirFile = new File(resourcesPath);
	    	subBaseDirFile.mkdirs();
		}
		
}
