package com.srs.quiltmaker.android;


import java.util.Properties;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.widget.LinearLayout;

import com.srs.android.widgets.CenteredImageView;
import com.srs.quiltmaker.android.util.StateStorageUtil;

public class SplashScreenActivity extends Activity {
	
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
    	
    	//
        // Initialize state
    	//
        Properties state = StateStorageUtil.initStateStorage(this);
        
    	//
    	// Build UI
    	//
        super.onCreate(savedInstanceState);
        
        LinearLayout layout = new LinearLayout(this);
        layout.setOrientation(LinearLayout.VERTICAL);
    
        CenteredImageView splashImage = new CenteredImageView(this);
        splashImage.setImageResource(R.raw.splashscreen);
        splashImage.setConsumeParentHeight(true);
        splashImage.setConsumeParentWidth(true);
        splashImage.setCenterVertical(false);
        layout.addView(splashImage);
        
        setContentView(layout);
        

        //
        // Create forwarding thread
        //
        MoveOn mo = new MoveOn(this,state);
        mo.start();
    }

	class  MoveOn extends Thread {
		
		Context ctxt;
		Properties props;
		
		MoveOn(Context c,Properties p) {
			ctxt = c;
			props = p;
		}
		
		public void run() {
			
			try {
				Thread.sleep(7000);
			} catch (InterruptedException e) {	}
			
			Intent intent = new Intent();
			
			String currentStep = props.getProperty("currentStep","backgroundSelect");
			
			if(currentStep.equals("backgroundSelect")) {
				//intent.setClass(SplashScreenActivity.this,BackgroundSelectionActivity.class);
				intent.setClass(SplashScreenActivity.this,InstructionScreen.class);
			} else if(currentStep.equals("subjectSelect")) {
				intent.setClass(SplashScreenActivity.this,SubjectSelectionActivity.class);
			} else if(currentStep.equals("accentOneSelect")) {
				intent.setClass(SplashScreenActivity.this,AccentOneSelectionActivity.class);
			} else if(currentStep.equals("accentTwoSelect")) {
				intent.setClass(SplashScreenActivity.this,AccentTwoSelectionActivity.class);
			} else if(currentStep.equals("greetingSelect")) {
				intent.setClass(SplashScreenActivity.this,GreetingSelectionActivity.class);
			} else if(currentStep.equals("orderDetailsSelect")) {
				intent.setClass(SplashScreenActivity.this,OrderDetailsActivity.class);
			} else {
				// bogus state ... start back at the beginning
				Log.e("SplashScreen","Bogus/Unknown app state.  Resetting to beginning.");
				//intent.setClass(SplashScreenActivity.this,BackgroundSelectionActivity.class);
				intent.setClass(SplashScreenActivity.this,InstructionScreen.class);
			}

			ctxt.startActivity(intent);
		}
	}
}