package com.srs.quiltmaker.android.ui;

import java.util.Properties;
import java.util.Vector;


import com.srs.android.widgets.LayeredImageView;
import com.srs.quiltmaker.android.SplashScreenActivity;
import com.srs.quiltmaker.android.ui.bean.Layer;
import com.srs.quiltmaker.android.util.StateStorageUtil;

import android.content.Context;
import android.content.Intent;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;


/**
 * A listener designed to support background selection on a Gallery.
 * 
 * @author k001694
 *
 */
public class BackgroundClickListener implements OnItemClickListener {

	private Vector items;
	private LayeredImageView view;
	private Layer layer;
	private Context ctxt;
	
	public BackgroundClickListener(Vector i,LayeredImageView v,Layer l,Context c) {
		items = i;
		view = v;
		layer = l;
		ctxt = c;
	}

	public void onItemClick(AdapterView<?> arg0, View arg1, int position, long arg3) {

		Log.d("BackgroundClickListener","clicked position " + position);
		
		Object selection = items.get(position);
		if(selection != null) {
			layer.setLayerData(selection);
			layer.setVisible(true);
			view.invalidate();
		}		
	}
}