package com.srs.quiltmaker.android.ui;

import java.util.Properties;



import com.srs.quiltmaker.android.SubjectSelectionActivity;
import com.srs.quiltmaker.android.ui.bean.Layer;
import com.srs.quiltmaker.android.ui.bean.QuiltBackgroundItem;
import com.srs.quiltmaker.android.util.StateStorageUtil;

import android.content.Context;
import android.content.Intent;
import android.view.View;
import android.view.View.OnClickListener;

public class BackgroundSelectNextClickListener implements OnClickListener {

	private Context ctxt;
	private Layer layer;
	
	public BackgroundSelectNextClickListener(Context c,Layer l) {
		ctxt = c;
		layer = l;
	}
	
	public void onClick(View arg0) {
		
		
		Properties appProps = StateStorageUtil.getStateData(ctxt);
		appProps.setProperty("currentStep","subjectSelect");
		
		QuiltBackgroundItem item = (QuiltBackgroundItem) layer.getLayerData();
		if(item != null) {
			item.storeToAppState(appProps,"background");
		}
		
		StateStorageUtil.saveStateData(ctxt,appProps);
			
		Intent intent = new Intent();
		intent.setClass(ctxt,SubjectSelectionActivity.class);
		ctxt.startActivity(intent);
	}

}
