package com.srs.quiltmaker.android.ui.bean;

import java.util.Properties;

import android.graphics.Bitmap;
import android.util.Log;

public class QuiltBackgroundItem {
	
	private Bitmap background;
	private Bitmap backgroundThum;
	private String name;
	private String backgroundThumFilename;
	private String backgroundFilename;
	private String rootDirectory;
	private int positionX;
	private int positionY;
	
	public QuiltBackgroundItem() {}
	
	public QuiltBackgroundItem(String name) {
		this.name = name;
	}

	public Bitmap getBackground() {
		return background;
	}

	public void setBackground(Bitmap background) {
		this.background = background;
	}

	public Bitmap getBackgroundThum() {
		return backgroundThum;
	}

	public void setBackgroundThum(Bitmap backgroundThum) {
		this.backgroundThum = backgroundThum;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getBackgroundThumFilename() {
		return backgroundThumFilename;
	}

	public void setBackgroundThumFilename(String backgroundThumFile) {
		this.backgroundThumFilename = backgroundThumFile;
	}

	public String getBackgroundFilename() {
		return backgroundFilename;
	}

	public void setBackgroundFilename(String backgroundFilename) {
		this.backgroundFilename = backgroundFilename;
	}
	
	public String getRootDirectory() {
		return rootDirectory;
	}

	public void setRootDirectory(String rootDirectory) {
		this.rootDirectory = rootDirectory;
	}

	public int getPositionX() {
		return positionX;
	}

	public void setPositionX(int positionX) {
		this.positionX = positionX;
	}

	public int getPositionY() {
		return positionY;
	}

	public void setPositionY(int positionY) {
		this.positionY = positionY;
	}

	public void storeToAppState(Properties props,String key) {
		props.setProperty(key + "." + "item","true");
		props.setProperty(key + "." + "name", name);
		props.setProperty(key + "." + "backgroundFilename",backgroundFilename);
		props.setProperty(key + "." + "backgroundThumFilename",backgroundThumFilename);
		props.setProperty(key + "." + "positionX",positionX + "");
		props.setProperty(key + "." + "positionY",positionY + "");
		props.setProperty(key + "." + "rootDirectory",this.rootDirectory);
	}
	
	public boolean loadableFromAppState(Properties props,String key) {
		if(props.getProperty(key + "." + "item") != null)
			return true;
		else
			return false;
	}
	
	public void loadFromAppState(Properties props,String key) {
		name = props.getProperty(key + "." + "name");
		backgroundFilename = props.getProperty(key + "." + "backgroundFilename");
		backgroundThumFilename =props.getProperty(key + "." + "backgroundThumFilename");
		rootDirectory = props.getProperty(key + "." + "rootDirectory");
		try {
			positionX = Integer.parseInt(props.getProperty(key + "." + "positionX","0"));
		} catch (Exception e) {
			Log.e("QuiltBagroundItem","loadFromAppState positionX parse error",e);
			positionX =0;
		}
		
		try {
			positionY = Integer.parseInt(props.getProperty(key + "." + "positionY","0"));
		} catch (Exception e) {
			Log.e("QuiltBagroundItem","loadFromAppState positionY parse error",e);
			positionY =0;
		}
	}
	
}
