package com.srs.quiltmaker.android.util;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;

import org.apache.http.util.ByteArrayBuffer;

import android.util.Log;

public class ImageDownloader {

	//public final static String BASE_URL = "http://www.solid-rock-solutions.com/";
	//public final static String BASE_URL = "http://10.129.56.94/rsi/admin/";
	public final static String BASE_URL = "http://www.solid-rock-solutions.com/";

	
    public void DownloadFromUrl(String imageURL, String fileName) {  //this is the downloader method

                try {
                        URL url = new URL(BASE_URL + imageURL); //you can write here any link
                        File file = new File(fileName);
                        long startTime = System.currentTimeMillis();

                        Log.d("ImageManager", "download begining");
                        Log.d("ImageManager", "download url:" + url);
                        Log.d("ImageManager", "downloaded file name:" + fileName);

                        /* Open a connection to that URL. */
                        HttpURLConnection conn= (HttpURLConnection) url.openConnection();
                        conn.setDoInput(true);
                        conn.connect();
                        int length = conn.getContentLength();
                        
                        Log.d("ImageManager","lengh of file is: " + length);
                        
                        
                        /*
                         * Define InputStreams to read from the URLConnection.
                         */
                        InputStream is = conn.getInputStream();
                        BufferedInputStream bis = new BufferedInputStream(is);
                        /*
                         * Read bytes to the Buffer until there is nothing more to read(-1).
                         */
                        ByteArrayBuffer baf = new ByteArrayBuffer(50);
                        int current = 0;
                        while ((current = bis.read()) != -1) {
                                baf.append((byte) current);
                        }

                        /* Convert the Bytes read to a String. */
                        FileOutputStream fos = new FileOutputStream(file);
                        fos.write(baf.toByteArray());
                        fos.close();
                        
                        // bmImg = BitmapFactory.decodeStream(is);
                        // imView.setImageBitmap(bmImg);
                        
                        Log.d("ImageManager", "download complete in "
                                        + ((System.currentTimeMillis() - startTime) / 1000)
                                        + " sec");
                } catch (IOException e) {
                        Log.d("ImageManager", "Error: " + e);
                        e.printStackTrace();
                }
        }
}

