package com.srs.quiltmaker.android.util;

import java.util.Properties;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.util.Log;

import com.srs.quiltmaker.android.ui.bean.Layer;
import com.srs.quiltmaker.android.ui.bean.QuiltBackgroundItem;

public class StateLoadingUtil {

    public static void loadSelectedBackground(Context ctxt, Layer l) {
    	
    	Properties appStateProps = StateStorageUtil.getStateData(ctxt);
    	QuiltBackgroundItem item = new QuiltBackgroundItem();
    	item.loadFromAppState(appStateProps, "background");
    	l.setLayerData(item);
    	
    	loadItemImages(item);
    }
    
    public static void loadSubjectBackground(Context ctxt, Layer l) {
    	
    	Properties appStateProps = StateStorageUtil.getStateData(ctxt);
    	QuiltBackgroundItem item = new QuiltBackgroundItem();
    	item.loadFromAppState(appStateProps, "subject");
    	l.setLayerData(item);
    	
    	loadItemImages(item);

    }
    
    public static void loadAccent1Background(Context ctxt,Layer l) {
    	Properties appStateProps = StateStorageUtil.getStateData(ctxt);
    	QuiltBackgroundItem item = new QuiltBackgroundItem();
    	if(item.loadableFromAppState(appStateProps,"accent1")) {
    		item.loadFromAppState(appStateProps, "accent1");
    		l.setLayerData(item);
    		loadItemImages(item);
    	}
    }
    
    public static void loadAccent2Background(Context ctxt,Layer l) {
    	Properties appStateProps = StateStorageUtil.getStateData(ctxt);
    	QuiltBackgroundItem item = new QuiltBackgroundItem();
    	if(item.loadableFromAppState(appStateProps,"accent2")) {
    		item.loadFromAppState(appStateProps, "accent2");
    		l.setLayerData(item);
    		loadItemImages(item);
    	}
    }
    
    static protected void loadItemImages(QuiltBackgroundItem item) {
    	Log.i("StateLoadingUtil","loadItemImages: " + item.getRootDirectory() + "/" + item.getBackgroundThumFilename());
    	//Bitmap img = BitmapFactory.decodeFile(item.getRootDirectory() + "/" + item.getBackgroundThumFilename());
    	//item.setBackgroundThum(img);
    	
    	Bitmap img=null;
    	img = BitmapFactory.decodeFile(item.getRootDirectory() + "/" + item.getBackgroundFilename());
    	item.setBackground(img);
    }
    
    /**
     * Utility method to load background image files into bitamaps and put them into the ui beans.
     * 
     * @param item
     */
    private static void loadBackgroundImages(QuiltBackgroundItem item,String root) {
    	Log.i("SubjectActivity","loadBackgroundImages: " + root + "/" + item.getBackgroundThumFilename());
    	//Bitmap img = BitmapFactory.decodeFile(root + "/" + item.getBackgroundThumFilename());
    	//item.setBackgroundThum(img);
    	
    	Bitmap img=null;
    	img = BitmapFactory.decodeFile(root + "/" + item.getBackgroundFilename());
    	item.setBackground(img);
    }
}
