package com.srs.quiltmaker.research;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.StringTokenizer;
import java.util.Vector;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Gallery;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.Gallery.LayoutParams;

import com.srs.quiltmaker.research.bean.QuiltBackgroundItem;


public class QuilteMaker extends Activity {

	public static String APP_DATA_ROOT="/data/data/com.srs.quiltmaker.android/";
	public static String WEB_DATA_ROOT="appdata/quiltmaker/";
	
	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //Vector bkgrnds = loadMyStuff(savedInstanceState);
    		
    	LinearLayout llout = new LinearLayout(this);
    	llout.setOrientation(LinearLayout.VERTICAL);

    	LinearLayout infoLayer = new LinearLayout(this);
    	infoLayer.setOrientation(LinearLayout.HORIZONTAL);
    	infoLayer.setLayoutParams(new LayoutParams(LayoutParams.FILL_PARENT,LayoutParams.WRAP_CONTENT));

    	llout.addView(infoLayer);
    	
    	//
    	// Add in progress bar
    	//
    	ProgressBar pb = new ProgressBar(this);
    	pb.setLayoutParams(new LayoutParams(LayoutParams.WRAP_CONTENT,LayoutParams.WRAP_CONTENT));
    	infoLayer.addView(pb);
    	
   
    	TextView tv = new TextView(this);
    	tv.setText(" Fetching Backgrounds ");
    	tv.setLayoutParams(new LayoutParams(LayoutParams.WRAP_CONTENT,LayoutParams.WRAP_CONTENT));
    	infoLayer.addView(tv);

    	
    	//
    	// Add in gallery
    	//
        Gallery g = (Gallery) new Gallery(this);
        
        ImageAdapter adptr = new ImageAdapter(this);
        //adptr.setItemVector(bkgrnds);
        
        g.setAdapter(adptr);
        g.setOnItemClickListener(new OnItemClickListener() {
            public void onItemClick(AdapterView parent, View v, int position, long id) {
                Toast.makeText(QuilteMaker.this, "" + position, Toast.LENGTH_SHORT).show();
            }
        });
        
        g.setLayoutParams(new LayoutParams(LayoutParams.FILL_PARENT,LayoutParams.WRAP_CONTENT));
        llout.addView(g);
        setContentView(llout);
        
        Handler mhandle = new Handler();
        SampleThread th = new SampleThread(mhandle,tv,pb);
        th.start();
    }
    
    
    Vector loadMyStuff(Bundle savedInstanceState) {
        Thread.yield();
    	ImageDownloader dn = new ImageDownloader();
    	dn.DownloadFromUrl(WEB_DATA_ROOT + "backgrounds.rc",QuilteMaker.APP_DATA_ROOT + "backgrounds.rc");
    	
    	Vector backgrounds= new Vector();
    	
    	try {
			BufferedReader rd = new BufferedReader(new FileReader(QuilteMaker.APP_DATA_ROOT + "backgrounds.rc"));
			String line=null;
			line = rd.readLine();
			while(line != null) {
				StringTokenizer st = new StringTokenizer(line,",");
				String name =st.nextToken();
				String fileThumb = st.nextToken();
				
				QuiltBackgroundItem bitem = new QuiltBackgroundItem();
				bitem.setName(name);
				bitem.setBackgroundThumFile(fileThumb);
				backgrounds.add(bitem);
				
				dn.DownloadFromUrl(WEB_DATA_ROOT + fileThumb,QuilteMaker.APP_DATA_ROOT + fileThumb);
				
				// move to next config line.
				line = rd.readLine();
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    	
    	return backgrounds;
    	
    }
    
}